package os

import (
	"fmt"
	"os"
	"runtime"
	"strings"
)

func GetCurrentProcessId() int {
	return os.Getpid()
}

func GetCurrentGoroutineId() string {
	buf := make([]byte, 128)
	buf = buf[:runtime.Stack(buf, false)]
	stackInfo := string(buf)

	return strings.TrimSpace(strings.Split(strings.Split(stackInfo, "[running]")[0], "goroutine")[1])
}

func GetCurrentProcessAndGoroutineIDStr() string {
	pid := GetCurrentProcessId()
	goroutineID := GetCurrentGoroutineId()

	return fmt.Sprintf("%d_%s", pid, goroutineID)
}
